#include "stats.h"
//vous trouverez ici les fonctions qui vont checker des stats de personnage


int carac_asker (char carac[])
{
	int deja=0;
	int i=1;
	
	for (i=0; i<=3;	i++)
	{
		carac[i]=0;
	}
		
	while (strcmp(carac, "STR\0")!=0 && strcmp(carac, "DEX\0")!=0 && strcmp(carac, "STA\0")!=0 && strcmp(carac, "CHA\0")!=0 && strcmp(carac, "MAN\0")!=0 && strcmp(carac, "APA\0")!=0 && strcmp(carac, "PER\0")!=0 && strcmp(carac, "INT\0")!=0 && strcmp(carac, "AST\0")!=0)
	{
		if(deja) printf("Désole, réponse non comprise\n");
		printf("Quelle caractéristique choissisez vous ?\n");
		printf("STR pour Force\n");
		printf("DEX pour Dextérité\n");
		printf("STA pour Vigeur\n");
		printf("CHA pour Carisme\n");
		printf("MAN pour Manipulation\n");
		printf("APA pour Aparence\n");
		printf("PER pour Perception\n");
		printf("INT pour Inteligence\n");
		printf("AST pour Astuce\n");
		scanf("%4s", carac);
		deja=1;
		carac[3]=0;
	}
	return 0;
}

int lire_entree(char *entree, int long_max)
{
	char *position_retour_ligne=NULL;
	
	if( fgets(entree, long_max, stdin) !=0)
	{
		position_retour_ligne = strchr(entree, '\n');
		
		if (position_retour_ligne!=NULL)
		{
			*position_retour_ligne = '\0';
			return 1;
		}
	}
		
	else return 0;
	
}

int verificateur_nom_perso(char *nom_perso, char perso_save[][NOM_MAX])
{
	int i=0;
		
	for (i=0; i<MAX_SAVE; i++)
	{
		if (strcmp(perso_save[i], nom_perso)==0) return 1;
	}
	
	return 0;
}

int dice_launcher(int nb_dice, int diff_dice, int *resultat_dice, int *win_dice, int current_dice[]) //return 0 si tout c'est bien passer, et trois pointeur sur trois variables, resultat_dice va déterminer si réssite (2), réussite critique (3), echec (1) ou echec critique (0)
{
	int i=0;
	int echec_critique=TRUE;
	srand(time(NULL));
	int un_dice=0;
	
	if (nb_dice>DICE_MAX)
	{
		printf("EREUR CRITIQUE, nombre de dés plus grand que le maximum (30), vérifier que les données ne soient pas corrompues\n"); //cette condition est pour éviter le buffer overflow, mesure de sécurité
		return 1;
	}
	
	else
	{
		for (i=0; i<nb_dice; i++)
		{
			
			current_dice[i]=rand() % 10 +1;
			
			if (current_dice[i] >= diff_dice)
			{
				echec_critique = FALSE;   //si au moins une réussit pas de echec critique
				*win_dice=*win_dice+1;
			}
			
			else if (current_dice[i]==1)
			{
				*win_dice=*win_dice-1;
				un_dice=un_dice+1;
			}
		
		}
						
		/* 4 cas possibles, soit réussite(2), soit réussite critique(3), soit echec(1), soit échec critique(0), on va assigner chaque résultat à un valeur de resultat_dice */
		
		if (*win_dice==0 && echec_critique==TRUE && un_dice > 0)
		{
			*resultat_dice=0;
			return 0;
		}
		
		else if (*win_dice==0)
		{
			*resultat_dice=1;
			return 0;
		}
		
		else if (*win_dice>=5)
		{
			*resultat_dice=3;
			return 0;
		}
		
		else if (*win_dice>0)
		{
			*resultat_dice=2;
			return 0;
		}
	}
}
			

int perso_scanner (Personnage *p_perso, char file_perso[])   //Algorithme trop stylé sa mère qui va aller lire dans les fichiers perso et mettre en mémoire vive toutes les données de tous les joeurs.
{
	FILE* fichier = NULL;
	char ligne[TAILLE_MAX] = "";
	fichier=fopen(file_perso, "r");
	int line_actuelle=0;
	int valeur=0;
	char clan[CLAN_MAX]="";
	char nom_perso[NOM_MAX]="";
	
	if (fichier != NULL)  //vérification que le fichier s'ouvre correctement
	{		
		while (fgets(ligne, TAILLE_MAX, fichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
        {
			
			recherche_valeur(ligne, &valeur);
			
			if (line_actuelle==0) //on est dans la première ligne, du coup on va lire le nom du perso
			{
				recherche_chaine(ligne, nom_perso);
				strcpy(p_perso->nom_perso, nom_perso);
				printf("\n---Nom du Personnage----\n");
				printf("%s\n", p_perso->nom_perso);
			}
			
			else if (line_actuelle==1)  //on attaque la deuxième ligne, qui nous donne le clan
			{
				recherche_chaine(ligne, clan);
				strcpy(p_perso->clan_perso, clan);
				printf("\n----------Clan----------\n");
				printf("%s\n", p_perso->clan_perso);
			}
			
			else if (line_actuelle==4)  //on attaque la cinquième ligne, qui nous donne la force, la cela deviens plus compliqué
			{
				p_perso->str_carac=valeur;
				printf("\n--------Atribus---------\n");
				printf("Force %d\n", p_perso-> str_carac);
			}	
			
			else if (line_actuelle==5)  //on attaque la sixième ligne, qui nous donne la dextérité
			{
				p_perso->dex_carac=valeur;
				printf("Dextérité %d\n", p_perso-> dex_carac);
			}	
			
			else if (line_actuelle==6)  //on attaque la septième ligne, qui nous donne la vigeur
			{
				p_perso->sta_carac=valeur;
				printf("Vigeur %d\n", p_perso-> sta_carac);
			}
			
			else if (line_actuelle==7)  //on attaque la huitième ligne, qui nous donne le charisme
			{
				p_perso->cha_carac=valeur;
				printf("Charisme %d\n", p_perso-> cha_carac);
			}
			
			else if (line_actuelle==8)  //on attaque la neuvième ligne, qui nous donne la manipulation
			{
				p_perso->man_carac=valeur;
				printf("Manipulation %d\n", p_perso->man_carac);
			}
			
			else if (line_actuelle==9)  //on attaque la dixième ligne, qui nous donne l'aparence
			{
				p_perso->apa_carac=valeur;
				printf("Aparence %d\n", p_perso->apa_carac);
			}
			
			else if (line_actuelle==10)  //on attaque la onzième ligne, qui nous donne la perception
			{
				p_perso->per_carac=valeur;
				printf("Perception %d\n", p_perso->per_carac);
			}
			
			else if (line_actuelle==11)  //on attaque la dousième ligne, qui nous donne l'inteligence
			{
				p_perso->int_carac=valeur;
				printf("Inteligence %d\n", p_perso->int_carac);
			}
			
			else if (line_actuelle==12)  //on attaque la treisième ligne, qui nous donne l'astuce
			{
				p_perso->ast_carac=valeur;
				printf("Astuce %d\n", p_perso->ast_carac);
			}
			
			else if (line_actuelle==16)  //on attaque maintenant les skills, je pense que vous avez compris du coup j'arrêtesles commentaires
			{	
				p_perso->adresse_skill=valeur;
				printf("\n-------Capacités--------\n");
				printf("Adresse %d\n", p_perso->adresse_skill);
			}
			
			else if (line_actuelle==17) 
			{	
				p_perso->athletisme_skill=valeur;
				printf("Athetisme %d\n", p_perso->athletisme_skill);
			}
			
			else if (line_actuelle==18) 
			{	
				p_perso->bagare_skill=valeur;
				printf("Bagare %d\n", p_perso->bagare_skill);
			}
			
			else if (line_actuelle==19) 
			{	
				p_perso->commandement_skill=valeur;
				printf("Commandement %d\n", p_perso->commandement_skill);
			}
			
			else if (line_actuelle==20)
			{
				p_perso->empathie_skill=valeur;
				printf("Empathie %d\n", p_perso->empathie_skill);
			}
			
			else if (line_actuelle==21)
			{
				p_perso->expression_skill=valeur;
				printf("Expression %d\n", p_perso->expression_skill);
			}
			
			else if (line_actuelle==22)
			{
				p_perso->intimidation_skill=valeur;
				printf("Intimidation %d\n", p_perso->intimidation_skill);
			}
			
			else if (line_actuelle==23)
			{
				p_perso->intuition_skill=valeur;
				printf("Intuition %d\n", p_perso->intuition_skill);
			}
			
			else if (line_actuelle==24)
			{
				p_perso->subterfuge_skill=valeur;
				printf("Subterfuge %d\n", p_perso->subterfuge_skill);
			}
			
			else if (line_actuelle==25)
			{
				p_perso->vigilance_skill=valeur;
				printf("Vigilance %d\n", p_perso->vigilance_skill);
			}
			
			else if (line_actuelle==27)
			{
				p_perso->animaux_skill=valeur;
				printf("Animaux %d\n", p_perso->animaux_skill);
			}
			
			else if (line_actuelle==28)
			{
				p_perso->artisanats_skill=valeur;
				printf("Artisanats %d\n", p_perso->artisanats_skill);
			}
			
			else if (line_actuelle==29)
			{
				p_perso->commerce_skill=valeur;
				printf("Commerce %d\n", p_perso->commerce_skill);
			}
			
			else if (line_actuelle==30)
			{
				p_perso->equitation_skill=valeur;
				printf("Equitation %d\n", p_perso->equitation_skill);
			}
				
			else if (line_actuelle==31)
			{
				p_perso->etiquette_skill=valeur;
				printf("Etiquette %d\n", p_perso->etiquette_skill);
			}
			
			else if (line_actuelle==32)
			{
				p_perso->furtivite_skill=valeur;
				printf("Furtivite %d\n", p_perso->furtivite_skill);
			}
			
			else if (line_actuelle==33)
			{
				p_perso->melee_skill=valeur;
				printf("Melee %d\n", p_perso->melee_skill);
			}
			
			else if (line_actuelle==34)
			{
				p_perso->representation_skill=valeur;
				printf("Representation %d\n", p_perso->representation_skill);
			}
			
			else if (line_actuelle==35)
			{
				p_perso->survie_skill=valeur;
				printf("Survie %d\n", p_perso->survie_skill);
			}
			
			else if (line_actuelle==36)
			{
				p_perso->arc_skill=valeur;
				printf("Arc %d\n", p_perso->arc_skill);
			}
			
			else if (line_actuelle==38)
			{
				p_perso->droit_skill=valeur;
				printf("Droit %d\n", p_perso->droit_skill);
			}
			
			else if (line_actuelle==39)
			{
				p_perso->enigmes_skill=valeur;
				printf("Enigme %d\n", p_perso->enigmes_skill);
			}
			
			else if (line_actuelle==40)
			{
				p_perso->erudition_skill=valeur;
				printf("Erudition %d\n", p_perso->erudition_skill);
			}
			
			else if (line_actuelle==41)
			{
				p_perso->investigation_skill=valeur;
				printf("Investigation %d\n", p_perso->investigation_skill);
			}
			
			else if (line_actuelle==42)
			{
				p_perso->medecine_skill=valeur;
				printf("Medecine %d\n", p_perso->medecine_skill);
			}
			
			else if (line_actuelle==43)
			{
				p_perso->occultisme_skill=valeur;
				printf("Occultisme %d\n", p_perso->occultisme_skill);
			}
			
			else if (line_actuelle==44)
			{
				p_perso->politique_skill=valeur;
				printf("Politique %d\n", p_perso->politique_skill);
			}
			
			else if (line_actuelle==45)
			{
				p_perso->sagessepop_skill=valeur;
				printf("Sagesse populaire %d\n", p_perso->sagessepop_skill);
			}
			
			else if (line_actuelle==46)
			{
				p_perso->senechal_skill=valeur;
				printf("Senechal %d\n", p_perso->senechal_skill);
			}
			
			else if (line_actuelle==47)
			{
				p_perso->theologie_skill=valeur;
				printf("Théologie %d\n", p_perso->theologie_skill);
			}
			
			else if (line_actuelle==51)   //on passe maintenant aux disciplines 
			{
				p_perso->might_dicipline=valeur;
				printf("\n-------Diciplines-------\n");
				printf("Puissance %d\n", p_perso->might_dicipline);
			}
			
			else if (line_actuelle==52)  
			{
				p_perso->dominate_dicipline=valeur;
				printf("Domination %d\n", p_perso->dominate_dicipline);
			}
			
			else if (line_actuelle==53)  
			{
				p_perso->obtenebrate_dicipline=valeur;
				printf("Obtenebration %d\n", p_perso->obtenebrate_dicipline);
			}
			
			else if (line_actuelle==54)  
			{
				p_perso->haste_dicipline=valeur;
				printf("Célérité %d\n", p_perso->haste_dicipline);
			}
			
			else if (line_actuelle==55)  
			{
				p_perso->dementation_dicipline=valeur;
				printf("Aliénation %d\n", p_perso->dementation_dicipline);
			}
			
			else if (line_actuelle==56)  
			{
				p_perso->animalism_dicipline=valeur;
				printf("Animalisme %d\n", p_perso->animalism_dicipline);
			}
			
			else if (line_actuelle==57)  
			{
				p_perso->auspex_dicipline=valeur;
				printf("Auspex %d\n", p_perso->auspex_dicipline);
			}
			
			else if (line_actuelle==58)  
			{
				p_perso->chismestry_dicipline=valeur;
				printf("Chimérie %d\n", p_perso->chismestry_dicipline);
			}
			
			else if (line_actuelle==59)  
			{
				p_perso->fortitude_dicipline=valeur;
				printf("Force d'âme %d\n", p_perso->fortitude_dicipline);
			}
			
			else if (line_actuelle==60)  
			{
				p_perso->mortis_dicipline=valeur;
				printf("Mortis %d\n", p_perso->mortis_dicipline);
			}
			
			else if (line_actuelle==61)  
			{
				p_perso->ofuscate_dicipline=valeur;
				printf("Occultation %d\n", p_perso->ofuscate_dicipline);
			}
			
			else if (line_actuelle==62)  
			{
				p_perso->presence_dicipline=valeur;
				printf("Pressense %d\n", p_perso->presence_dicipline);
			}
			
			else if (line_actuelle==63)  
			{
				p_perso->protean_dicipline=valeur;
				printf("Proteisme %d\n", p_perso->protean_dicipline);
			}
			
			else if (line_actuelle==64)  
			{
				p_perso->quietus_dicipline=valeur;
				printf("Quietus %d\n", p_perso->quietus_dicipline);
			}
			
			else if (line_actuelle==65)  
			{
				p_perso->serpentis_dicipline=valeur;
				printf("Serpentis %d\n", p_perso->serpentis_dicipline);
			}
			
			else if (line_actuelle==66)  
			{
				p_perso->thaumaturgy_dicipline=valeur;
				printf("Thaumaturgie %d\n", p_perso->thaumaturgy_dicipline);
			}
			
			else if (line_actuelle==67)  
			{
				p_perso->vississitude_dicipline=valeur;
				printf("Vississitude %d\n", p_perso->vississitude_dicipline);
			}
			
			else if (line_actuelle==68)  
			{
				p_perso->fly_dicipline=valeur;
				printf("Vol %d\n", p_perso->fly_dicipline);
			}
			
			else if (line_actuelle==72)   //cette petite section c'est pour les voies tremere 
			{
				p_perso->fire_tre=valeur;
				printf("\n-----Voies Tremere------\n");
				if (valeur==1)	printf("Voie du feux VRAI\n");
				else printf("Voie du feu FAUX\n");
			}
			
			else if (line_actuelle==73)   
			{
				p_perso->water_tre=valeur;
				if (valeur==1)	printf("Voie de l'eau VRAI\n");
				else printf("Voie de l'eau FAUX\n");
			}
			
			else if (line_actuelle==74)   
			{
				p_perso->element_tre=valeur;
				if (valeur==1)	printf("Voie des élements VRAI\n");
				else printf("Voie des élements FAUX\n");
			}
			
			else if (line_actuelle==75)   
			{
				p_perso->telek_tre=valeur;
				if (valeur==1)	printf("Voie de la télékinésie VRAI\n");
				else printf("Voie de la télékinésie FAUX\n");
			}
			
			else if (line_actuelle==76)   
			{
				p_perso->blood_tre=valeur;
				if (valeur==1)	printf("Voie du sang VRAI\n");
				else printf("Voie du sang FAUX\n");
			}
			
			else if (line_actuelle==80)    //on passe maintenants aux vertues
			{
				p_perso->con_vertus=valeur;
				printf("\n--------Vertues---------\n");
				printf("Conscience %d\n", p_perso->con_vertus);
			}
			
			else if (line_actuelle==81)    
			{
				p_perso->self_vertus=valeur;
				printf("Maitrise de soi %d\n", p_perso->self_vertus);
			}
			
			else if (line_actuelle==82)    
			{
				p_perso->courage_vertus=valeur;
				printf("Courage %d\n", p_perso->courage_vertus);
			}
			
			else if (line_actuelle==86)    //Et maintenant la volonté    
			{
				p_perso->will_power=valeur;
				printf("Volonté %d\n", p_perso->will_power);
			}
			
			else if (line_actuelle==90) //Puis pour finir la voie !!!! Et c'est finis !!!
			{
				recherche_chaine(ligne, nom_perso);
				strcpy(p_perso->voie_token, nom_perso);
				printf("\n---------Voies----------\n");
				printf("Voie %s\n", p_perso->voie_token);
			}
			
			else if (line_actuelle==91) 
			{
				p_perso->voie=valeur;
				printf("Voie %d\n", p_perso->voie);
			}
			
			else if (line_actuelle==94)  //on regarde maintenant les pds et la gen
			{
				p_perso->pds=valeur;
				printf("\n--Réserve sang&pouvoir--\n");
				printf("Points de Sang %d\n", p_perso->pds);
			}
			
			else if (line_actuelle==95)
			{
				p_perso->gen=valeur;
				printf("Génération %d\n", p_perso->gen);
			}	
					
		line_actuelle++;   //on passe à la prochaine ligne en fin de boucle, ansi le programme fera ligne par ligne
		}

		fclose(fichier);
	}
	
	else 
	{	
		printf("Impossible d'ouvrir le fichier\n");
		return 0;
	}
	
	return 1;
}

void get_interval(int *p_coordone_egale, int *p_coordone_fin, char *ligne)
{
	int i=0;
	for (i=0; i<TAILLE_MAX; i++) //on va dans cette boucle enregistrer le positionement dans le tableau du caractère '=' et le caractère '\0' car dans le fichier ce qui a entre ces deux caractères nous interesse
	{
		if (ligne[i]=='=') *p_coordone_egale=i;
		if (ligne[i]=='\n')
		{
			*p_coordone_fin=i;
			i=TAILLE_MAX;
		}
	}
}

void recherche_valeur(char ligne[], int *valeur)
{
	int coordone_egale=0;
	int coordone_fin=0;
	int taille_ligne=0;
	int k=0;
	int i=0;
	int buffer_valeur[2]={0};
	get_interval(&coordone_egale, &coordone_fin, ligne);
	taille_ligne=coordone_fin - 1 - (coordone_egale+2);			//on ajuste la taille de la ligne en ne comptant pas le \0 de la fin ni le = et le espace du début.
	
	if (taille_ligne!=1)
	{	
		for (i=coordone_egale+2; i<coordone_fin; i++)                 //on va chercher la valeur puis on la transforme en int, car sur le fichier le nombre est un caractère et non pas un nombre 
		{
			if (ligne[i]!='\n')
			{
				*valeur=ligne[i]-'0';
				k++;
			}
		}
	}
	else 
	{
		for (i=coordone_egale+2; i<coordone_fin; i++)                 //on va chercher la valeur puis on la transforme en int, car sur le fichier le nombre est un caractère et non pas un nombre 
		{
			if (ligne[i]!='\n')
			{
				buffer_valeur[k]=ligne[i]-'0';
				k++;
			}
		}	
		buffer_valeur[0]=buffer_valeur[0]*10;
		*valeur=buffer_valeur[0]+buffer_valeur[1];
	}
}

void recherche_chaine(char ligne[], char chaine[])
{
	int coordone_egale=0;
	int coordone_fin=0;
	int taille_ligne=0;
	int k=0;
	int i=0;
	get_interval(&coordone_egale, &coordone_fin, ligne);
	taille_ligne=coordone_fin - 1 - (coordone_egale+2);			//on ajuste la taille de la ligne en ne comptant pas le \0 de la fin ni le = et le espace du début.
	for (i=coordone_egale+2; i<coordone_fin; i++)                 //on copie la chaine de caractère ne mémoire vive pour utilisation par la suite dans le programme 
	{
		if (ligne[i]!='\n')
		{
			chaine[k]=ligne[i]; //on veut commencer par k=0 pour que le tableau en mémoire vive stocke la chaine de caractère à partir du premier emplacement (et non pas le xième)
			k++;
		}
	}
}

void menu_dice(int *nb_dice, Personnage *p_Perso)
{
	int deja=FALSE;
	struct Reponse
	{	
		int quel_donnee;                              //1 pour attribu, 2 pour competence, 3 pour dicipline, 4 pour vertues, 5 pour voie
		int attribu;
		int competence;
		int dicipline;
		int vertues;
	};
	int i=0;
	int simple_ou_double =0;
	int tab_attribu[NB_ATTRIBU]={0};
	int tab_competence[NB_COMPETENCES]={0};
	int tab_dicipline[NB_DICIPLINE]={0};
	int tab_vertues[NB_VERTUES]={0};
	int voie_buffer=0;
	int dice_buffer[2]={0};
	char entree[4]={0};
	
	struct Reponse Reponse[2] = {{0,0,0,0,0}, {0,0,0,0,0}};	//au maximum dans vampire deux variables sont appelées, du coup on ne peut que faire appel à deux données au maximum
	
	//Nous avons donc une structure qui est la pour pointer vers quelle donnée il faut y aller. Nous avons dejà en fonction de la structure quel_donnee ou ill va falloir chercher
	//Le plus simple sera donc faire 5 fonctions différentes, une par type de donnée.
	//nous allons faire donc appel à 5 fonctions différentes qui vont chacune enregistrer sur un tableau spécifique les données dans la structure Personnage
	
	enregistrer_attribu(tab_attribu, p_Perso);
	enregistrer_competences(tab_competence, p_Perso);
	enregistrer_dicipline(tab_dicipline, p_Perso);
	enregistrer_vertues(tab_vertues, p_Perso);
	enregistrer_voie(&voie_buffer, p_Perso);
	printf("Voulez-vous lancer un dé simple (1) - une seule donnée - ou double - deux données - (2) ?\n");
	while (lire_entree(entree, 4)!=1 || verificateur_simple_double(entree, &simple_ou_double)!=1)
	{
		printf("ERREUR : Réponse invalide !\n");
		printf("Voulez-vous lancer un dé simple (1) - une seule donnée - ou double - deux données - (2) ?\n");
		deja=TRUE;
	}
	
	if (simple_ou_double==1)
	{
		printf("Quelle donnée voulez-vous demander (rentrez le numéros correspondant) ?\n"); //demande à l'utilisateur quel donnée il cherche
		printf("1 - Attribu (force, dextére, apparence, etc...)\n");
		printf("2 - Compétence (melee, enigme, adresse, etc...\n");
		printf("3 - Dicipline (obténébration, ocultation, célérité, etc...)\n");
		printf("4 - Vertues (conscience, maitrise de soi, volonté, courage)\n");
		printf("5 - Voie\n");
		while (lire_entree(entree, 4)!=1 || verificateur_menu(entree, &Reponse[1].quel_donnee)!=1)
		{
			printf("ERREUR : Réponse invalide\n");
			printf("Quelle donnée voulez-vous demander (rentrez le numéros correspondant) ?\n"); //demande à l'utilisateur quel donnée il cherche
			printf("1 - Attribu (force, dextére, apparence, etc...)\n");
			printf("2 - Compétence (melee, enigme, adresse, etc...\n");
			printf("3 - Dicipline (obténébration, ocultation, célérité, etc...)\n");
			printf("4 - Vertues (conscience, maitrise de soi, volonté, courage)\n");
			printf("5 - Voie\n");
		}
		
		if(Reponse[1].quel_donnee==1)  //dans ce cas de figure, nous sommes dans l'attribu, du coup, on va maintenant proposer un menu attribu, et stocker la réponse dans la strcuture Reponse
		{
			printf("Quel attribu voulez-vous demander ? (rentrez le numéros correspondant)\n");
			printf("1 - Force      2 - Dextérité     3 - Vigeur\n");
			printf("4 - Charisme   5 - Manipulation  6 - Aparence\n");
			printf("7 - Perception 8 - Inteligence   9 - Astuce\n");
			while(lire_entree(entree, 4)!=1 || verificateur_attribu(entree, &Reponse[1].attribu)!=1)
			{
				printf("ERREUR : Réponse invalide\n");
				printf("Quel attribu voulez-vous demander ? (rentrez le numéros correspondant)\n");
				printf("1 - Force      2 - Dextérité     3 - Vigeur\n");
				printf("4 - Charisme   5 - Manipulation  6 - Aparence\n");
			    printf("7 - Perception 8 - Inteligence   9 - Astuce\n");
			}
			*nb_dice=tab_attribu[Reponse[1].attribu - 1];
		}
		
		else if (Reponse[1].quel_donnee==2)
		{
			printf("Quelle compétence voulez-vous demander ? (rentrez le numéros correspondant)\n");
			printf("1 - Adresse        2 - Athetisme      3 - Bagare         4 - Commandement\n");  
			printf("5 - Empathie       6 - Expression     7 - Intimidation   8 - Intuition\n");     
			printf("9 - Subterfuge     10 - Vigilance     11 - Animaux       12 - Artisanats\n");   
			printf("13 - Commerce      14 - Equitation    15 - Etiquette     16 - Furtivité\n"); 
			printf("17 - Melee         18 - Representation19 - Survie        20 - Tir à l'arc)\n"); 
			printf("21 - Droit         22 - Enigmes       23 - Erudition     24 - Investigation\n");  
			printf("25 - Medecine      26 - Occultisme    27 - Politique     28 - Sagesse Populaire)\n"); 
			printf("29 - Senechal      30 - Theologie\n");
			while(lire_entree(entree, 4)!=1 || verificateur_competence(entree, &Reponse[1].competence)!=1)
			{
				printf("ERREUR : Réponse invalide\n");
				printf("Quelle compétence voulez-vous demander ? (rentrez le numéros correspondant)\n");
				printf("1 - Adresse        2 - Athetisme      3 - Bagare         4 - Commandement\n");  
				printf("5 - Empathie       6 - Expression     7 - Intimidation   8 - Intuition\n");     
				printf("9 - Subterfuge     10 - Vigilance     11 - Animaux       12 - Artisanats\n");   
				printf("13 - Commerce      14 - Equitation    15 - Etiquette     16 - Furtivité\n"); 
				printf("17 - Melee         18 - Representation19 - Survie        20 - Tir à l'arc)\n"); 
				printf("21 - Droit         22 - Enigmes       23 - Erudition     24 - Investigation\n");  
				printf("25 - Medecine      26 - Occultisme    27 - Politique     28 - Sagesse Populaire)\n"); 
				printf("29 - Senechal      30 - Theologie\n");
			}
			*nb_dice=tab_competence[Reponse[1].competence - 1];
		}
		
		else if (Reponse[1].quel_donnee==3)
		{
			printf("1 - Puissance     2 - Domination    3 - Obtenebration 4 - Célérité\n");      
			printf("5 - Dementation   6 - Animalisme    7 - Auspex        8 - Chimérie\n");  
			printf("9 - Force d'âme   10 - Mortis       11 - Ofuscation   12 - Presence\n");
			printf("13 - Proteisme    14 - Quietus      15 - Serpentis    16 - Thaumaturgie\n");  
			printf("17 - Vississitude 18 - Vol\n");
			while(lire_entree(entree, 4)!=1 || verificateur_dicipline(entree, &Reponse[1].dicipline)!=1)	
			{
				printf("ERREUR : Réponse invalide\n"); 
				printf("1 - Puissance     2 - Domination    3 - Obtenebration 4 - Célérité\n");      
				printf("5 - Dementation   6 - Animalisme    7 - Auspex        8 - Chimérie\n");  
				printf("9 - Force d'âme   10 - Mortis       11 - Ofuscation   12 - Presence\n");
				printf("13 - Proteisme    14 - Quietus      15 - Serpentis    16 - Thaumaturgie\n");  
				printf("17 - Vississitude 18 - Vol\n");
			}
			*nb_dice=tab_dicipline[Reponse[1].dicipline - 1];
		}
		
		else if (Reponse[1].quel_donnee==4)
		{
			printf("1 - Conscience  2 - Maîtrise de soi  3 - Courage  4 - Volonté\n");
			while(lire_entree(entree, 4)!=1 || verificateur_vertue(entree, &Reponse[1].vertues)!=1)	
			{
				printf("ERREUR : Réponse invalide\n");
				printf("1 - Conscience  2 - Maîtrise de soi  3 - Courage  4 - Volonté\n");
			}
			*nb_dice=tab_vertues[Reponse[1].vertues - 1];
		}
		
		else if (Reponse[1].quel_donnee==5) *nb_dice=voie_buffer;
						
	}
	
    else if (simple_ou_double==2)
	{
		
		for (i=0; i<2; i++)
		{
			if(i==0) printf("-----Première donnée -----\n");  //premier round, recherche de la première donnée 
			else if(i==1) printf("-----Deuxième donnée -----\n");  //premier round, recherche de la première donnée
			
			printf("Quelle donnée voulez-vous demander (rentrez le numéros correspondant) ?\n"); //demande à l'utilisateur quel donnée il cherche
			printf("1 - Attribu (force, dextére, apparence, etc...)\n");
			printf("2 - Compétence (melee, enigme, adresse, etc...\n");
			printf("3 - Dicipline (obténébration, ocultation, célérité, etc...)\n");
			printf("4 - Vertues (conscience, maitrise de soi, volonté, courage)\n");
			printf("5 - Voie\n");
			
			while (lire_entree(entree, 4)!=1 || verificateur_menu(entree, &Reponse[i].quel_donnee)!=1)
			{
				printf("ERREUR : Réponse invalide\n");
				printf("Quelle donnée voulez-vous demander (rentrez le numéros correspondant) ?\n"); //demande à l'utilisateur quel donnée il cherche
				printf("1 - Attribu (force, dextére, apparence, etc...)\n");
				printf("2 - Compétence (melee, enigme, adresse, etc...\n");
				printf("3 - Dicipline (obténébration, ocultation, célérité, etc...)\n");
				printf("4 - Vertues (conscience, maitrise de soi, volonté, courage)\n");
				printf("5 - Voie\n");
			}
			
			if(Reponse[i].quel_donnee==1)  //dans ce cas de figure, nous sommes dans l'attribu, du coup, on va maintenant proposer un menu attribu, et stocker la réponse dans la strcuture Reponse
			{
				printf("Quel attribu voulez-vous demander ? (rentrez le numéros correspondant)\n");
				printf("1 - Force      2 - Dextérité     3 - Vigeur\n");
				printf("4 - Charisme   5 - Manipulation  6 - Aparence\n");
				printf("7 - Perception 8 - Inteligence   9 - Astuce\n");
				while(lire_entree(entree, 4)!=1 || verificateur_attribu(entree, &Reponse[i].attribu)!=1)
				{
					printf("ERREUR : Réponse invalide\n");
					printf("Quel attribu voulez-vous demander ? (rentrez le numéros correspondant)\n");
					printf("1 - Force      2 - Dextérité     3 - Vigeur\n");
					printf("4 - Charisme   5 - Manipulation  6 - Aparence\n");
					printf("7 - Perception 8 - Inteligence   9 - Astuce\n");
				}
				dice_buffer[i]=tab_attribu[Reponse[i].attribu - 1];
			}
			
			else if (Reponse[i].quel_donnee==2)
			{
				printf("Quelle compétence voulez-vous demander ? (rentrez le numéros correspondant)\n");
				printf("1 - Adresse        2 - Athetisme      3 - Bagare         4 - Commandement\n");  
				printf("5 - Empathie       6 - Expression     7 - Intimidation   8 - Intuition\n");     
				printf("9 - Subterfuge     10 - Vigilance     11 - Animaux       12 - Artisanats\n");   
				printf("13 - Commerce      14 - Equitation    15 - Etiquette     16 - Furtivité\n"); 
				printf("17 - Melee         18 - Representation19 - Survie        20 - Tir à l'arc)\n"); 
				printf("21 - Droit         22 - Enigmes       23 - Erudition     24 - Investigation\n");  
				printf("25 - Medecine      26 - Occultisme    27 - Politique     28 - Sagesse Populaire)\n"); 
				printf("29 - Senechal      30 - Theologie\n");
				while(lire_entree(entree, 4)!=1 || verificateur_competence(entree, &Reponse[i].competence)!=1)
				{
					printf("ERREUR : Réponse invalide\n");
					printf("Quelle compétence voulez-vous demander ? (rentrez le numéros correspondant)\n");
					printf("1 - Adresse        2 - Athetisme      3 - Bagare         4 - Commandement\n");  
					printf("5 - Empathie       6 - Expression     7 - Intimidation   8 - Intuition\n");     
					printf("9 - Subterfuge     10 - Vigilance     11 - Animaux       12 - Artisanats\n");   
					printf("13 - Commerce      14 - Equitation    15 - Etiquette     16 - Furtivité\n"); 
					printf("17 - Melee         18 - Representation19 - Survie        20 - Tir à l'arc)\n"); 
					printf("21 - Droit         22 - Enigmes       23 - Erudition     24 - Investigation\n");  
					printf("25 - Medecine      26 - Occultisme    27 - Politique     28 - Sagesse Populaire)\n"); 
					printf("29 - Senechal      30 - Theologie\n");
				}
				dice_buffer[i]=tab_competence[Reponse[i].competence - 1];
			}
			
			else if (Reponse[i].quel_donnee==3)
			{
				printf("1 - Puissance     2 - Domination    3 - Obtenebration 4 - Célérité\n");      
				printf("5 - Dementation   6 - Animalisme    7 - Auspex        8 - Chimérie\n");  
				printf("9 - Force d'âme   10 - Mortis       11 - Ofuscation   12 - Presence\n");
				printf("13 - Proteisme    14 - Quietus      15 - Serpentis    16 - Thaumaturgie\n");  
				printf("17 - Vississitude 18 - Vol\n");
				while(lire_entree(entree, 4)!=1 || verificateur_dicipline(entree, &Reponse[i].dicipline)!=1)	
				{
					printf("ERREUR : Réponse invalide\n"); 
					printf("1 - Puissance     2 - Domination    3 - Obtenebration 4 - Célérité\n");      
					printf("5 - Dementation   6 - Animalisme    7 - Auspex        8 - Chimérie\n");  
					printf("9 - Force d'âme   10 - Mortis       11 - Ofuscation   12 - Presence\n");
					printf("13 - Proteisme    14 - Quietus      15 - Serpentis    16 - Thaumaturgie\n");  
					printf("17 - Vississitude 18 - Vol\n");
				}
				dice_buffer[i]=tab_dicipline[Reponse[i].dicipline - 1];
			}
			
			else if (Reponse[i].quel_donnee==4)
			{
				printf("1 - Conscience  2 - Maîtrise de soi  3 - Courage  4 - Volonté\n");
				while(lire_entree(entree, 4)!=1 || verificateur_vertue(entree, &Reponse[i].vertues)!=1)
				{
					printf("ERREUR : Réponse invalide\n");
					printf("1 - Conscience  2 - Maîtrise de soi  3 - Courage  4 - Volonté\n");
				}
				dice_buffer[i]=tab_vertues[Reponse[i].vertues - 1];
			}
			
			else if (Reponse[i].quel_donnee==5) dice_buffer[i]=voie_buffer;
		}
	
		*nb_dice=dice_buffer[0]+dice_buffer[1];
	
	}
	
	
}


void enregistrer_attribu (int tab_attribu[], Personnage *p_Perso)
{
	int i=0;
	
	for(i=0; i<NB_ATTRIBU; i++)
	{
		if(i==0) tab_attribu[i]=p_Perso->str_carac;
		if(i==1) tab_attribu[i]=p_Perso->dex_carac;
		if(i==2) tab_attribu[i]=p_Perso->sta_carac;
		if(i==3) tab_attribu[i]=p_Perso->cha_carac;
		if(i==4) tab_attribu[i]=p_Perso->man_carac;
		if(i==5) tab_attribu[i]=p_Perso->apa_carac;
		if(i==6) tab_attribu[i]=p_Perso->per_carac;
		if(i==7) tab_attribu[i]=p_Perso->ast_carac;
		if(i==8) tab_attribu[i]=p_Perso->int_carac;
	}
}
	
void enregistrer_competences (int tab_competence[], Personnage *p_Perso)
{
	int i=0;
	
	for(i=0; i<NB_COMPETENCES; i++)
	{
		if(i==0) tab_competence[i]=p_Perso->adresse_skill;
		else if(i==1) tab_competence[i]=p_Perso->athletisme_skill;
		else if(i==2) tab_competence[i]=p_Perso->bagare_skill;
		else if(i==3) tab_competence[i]=p_Perso->commandement_skill;
		else if(i==4) tab_competence[i]=p_Perso->empathie_skill;
		else if(i==5) tab_competence[i]=p_Perso->expression_skill;
		else if(i==6) tab_competence[i]=p_Perso->intimidation_skill;
		else if(i==7) tab_competence[i]=p_Perso->intuition_skill;
		else if(i==8) tab_competence[i]=p_Perso->subterfuge_skill;
		else if(i==9) tab_competence[i]=p_Perso->vigilance_skill;
		else if(i==10) tab_competence[i]=p_Perso->animaux_skill;
		else if(i==11) tab_competence[i]=p_Perso->artisanats_skill;
		else if(i==12) tab_competence[i]=p_Perso->commerce_skill;
		else if(i==13) tab_competence[i]=p_Perso->equitation_skill;
		else if(i==14) tab_competence[i]=p_Perso->etiquette_skill;
		else if(i==15) tab_competence[i]=p_Perso->furtivite_skill;
		else if(i==16) tab_competence[i]=p_Perso->melee_skill;
		else if(i==17) tab_competence[i]=p_Perso->representation_skill;
		else if(i==18) tab_competence[i]=p_Perso->survie_skill;
		else if(i==19) tab_competence[i]=p_Perso->arc_skill;
		else if(i==20) tab_competence[i]=p_Perso->droit_skill;
		else if(i==21) tab_competence[i]=p_Perso->enigmes_skill;
		else if(i==22) tab_competence[i]=p_Perso->erudition_skill;
		else if(i==23) tab_competence[i]=p_Perso->investigation_skill;
		else if(i==24) tab_competence[i]=p_Perso->medecine_skill;
		else if(i==25) tab_competence[i]=p_Perso->occultisme_skill;
		else if(i==26) tab_competence[i]=p_Perso->politique_skill;
		else if(i==27) tab_competence[i]=p_Perso->sagessepop_skill;
		else if(i==28) tab_competence[i]=p_Perso->senechal_skill;
		else if(i==29) tab_competence[i]=p_Perso->theologie_skill;
	}
}

void enregistrer_dicipline (int tab_dicipline[], Personnage *p_Perso)
{
	int i=0;
	
	for(i=0; i<NB_DICIPLINE; i++)
	{
		if(i==0) tab_dicipline[i]=p_Perso->might_dicipline;
		else if(i==1) tab_dicipline[i]=p_Perso->dominate_dicipline;
		else if(i==2) tab_dicipline[i]=p_Perso->obtenebrate_dicipline;
		else if(i==3) tab_dicipline[i]=p_Perso->haste_dicipline;
		else if(i==4) tab_dicipline[i]=p_Perso->dementation_dicipline;
		else if(i==5) tab_dicipline[i]=p_Perso->animalism_dicipline;
		else if(i==6) tab_dicipline[i]=p_Perso->auspex_dicipline;
		else if(i==7) tab_dicipline[i]=p_Perso->chismestry_dicipline;
		else if(i==8) tab_dicipline[i]=p_Perso->fortitude_dicipline;
		else if(i==9) tab_dicipline[i]=p_Perso->mortis_dicipline;
		else if(i==10) tab_dicipline[i]=p_Perso->ofuscate_dicipline;
		else if(i==11) tab_dicipline[i]=p_Perso->presence_dicipline;
		else if(i==12) tab_dicipline[i]=p_Perso->protean_dicipline;
		else if(i==13) tab_dicipline[i]=p_Perso->quietus_dicipline;
		else if(i==14) tab_dicipline[i]=p_Perso->serpentis_dicipline;
		else if(i==15) tab_dicipline[i]=p_Perso->thaumaturgy_dicipline;
		else if(i==16) tab_dicipline[i]=p_Perso->vississitude_dicipline;
		else if(i==17) tab_dicipline[i]=p_Perso->fly_dicipline;
	}
}
	
void enregistrer_vertues (int tab_vertues[], Personnage *p_Perso)
{
	int i=0;
	
	for(i=0; i<NB_VERTUES; i++)
	{
		if(i==0) tab_vertues[i]=p_Perso->con_vertus; 
		else if(i==1) tab_vertues[i]=p_Perso->self_vertus; 
		else if(i==2) tab_vertues[i]=p_Perso->courage_vertus; 
		else if(i==3) tab_vertues[i]=p_Perso->will_power; 
	}
}	
	
void enregistrer_voie (int *voie, Personnage *p_Perso)
{
	*voie=p_Perso->voie;
}

int verificateur_diff (char entree_diff[], int *diff_dice)
{
	*diff_dice = atoi(entree_diff);
	
	if (*diff_dice<=10 && *diff_dice>=1) return 1;
	else return 0;
}

int verificateur_attribu (char entree_diff[], int *menu)
{
	*menu = atoi(entree_diff);
	
	if (*menu<= NB_ATTRIBU && *menu>=1) return 1;
	else return 0;
}

int verificateur_competence (char entree_diff[], int *menu)
{
	*menu = atoi(entree_diff);
	
	if (*menu<= NB_COMPETENCES && *menu>=1) return 1;
	else return 0;
}

int verificateur_dicipline (char entree_diff[], int *menu)
{
	*menu = atoi(entree_diff);
	
	if (*menu<= NB_DICIPLINE && *menu>=1) return 1;
	else return 0;
}

int verificateur_vertue (char entree_diff[], int *menu)
{
	*menu = atoi(entree_diff);
	
if (*menu<=NB_VERTUES && *menu>=1) return 1;
	else return 0;
}

int verificateur_menu (char entree_diff[], int *menu)
{
	*menu = atoi(entree_diff);
	
	if (*menu<=5 && *menu>=1) return 1;
	else return 0;

}

int verificateur_simple_double (char entree[], int *menu)
{
	*menu=atoi(entree);
	
	if (*menu==1 || *menu==2) return 1;
	else return 0;
}