#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <dirent.h>
#include <sys/types.h>
#define TAILLE 4
#define TAILLE_MAX 1000
#define TRUE 1
#define FALSE 0
#define NOM_MAX 50
#define CLAN_MAX 5
#define DICE_MAX 40
#define NB_ATTRIBU 9
#define NB_COMPETENCES 30
#define NB_DICIPLINE 18
#define NB_VERTUES 4
#define MAX_SAVE 1000

typedef struct Personnage Personnage;

struct Personnage
{
	//Nom du perso
	
	char nom_perso[NOM_MAX];
	
	//Clan
	
	char clan_perso[CLAN_MAX];
	
	//Ici sont toutes les attributs
	int str_carac;
	int dex_carac;
	int sta_carac;
	int cha_carac;
	int man_carac;
	int apa_carac;
	int per_carac;
	int ast_carac;
	int int_carac;
	
	//ici sont les capacités qui se finissent toutes avec _skill
	
	int adresse_skill;
	int athletisme_skill;
	int bagare_skill;
	int commandement_skill;
	int empathie_skill;
	int expression_skill;
	int intimidation_skill;
	int intuition_skill;
	int subterfuge_skill;
	int vigilance_skill;

	int animaux_skill;
	int artisanats_skill;
	int commerce_skill;
	int equitation_skill;
	int etiquette_skill;
	int furtivite_skill;
	int melee_skill;
	int representation_skill;
	int survie_skill;
	int arc_skill;

	int droit_skill;
	int enigmes_skill;
	int erudition_skill;
	int investigation_skill;
	int medecine_skill;
	int occultisme_skill;
	int politique_skill;
	int sagessepop_skill;
	int senechal_skill;
	int theologie_skill;
	
	//ici sont toutes les diciplines
	
	int might_dicipline;
	int dominate_dicipline;
	int obtenebrate_dicipline;
	int haste_dicipline;
	int dementation_dicipline;
	int animalism_dicipline;
	int auspex_dicipline;
	int chismestry_dicipline;
	int fortitude_dicipline;
	int mortis_dicipline;
	int ofuscate_dicipline;
	int presence_dicipline;
	int protean_dicipline;
	int quietus_dicipline;
	int serpentis_dicipline;
	int thaumaturgy_dicipline;
	int vississitude_dicipline;
	int fly_dicipline;
	
	//ici sont les voies TREMERE
	
	int fire_tre;
	int water_tre;
	int element_tre;
	int telek_tre;
	int blood_tre;
	
	//Ici sont les vertues
	
	int con_vertus;
	int self_vertus;
	int courage_vertus;
	
	//Ici le willpower
	
	int will_power;
	
	//ici la voie
	int voie;
	char voie_token[NOM_MAX];
	
	//ici la rserve de pds et gnration
	int pds;
	int gen;
};	
		

//Vous trouverez ici toutes les fonctions qui ont comme but checker des statistiques

int perso_scanner (Personnage *p_perso, char file_perso[]);
int carac_asker (char carac[]);
void get_interval(int *p_coordone_egale, int *p_coordone_fin, char *ligne);
void recherche_valeur(char ligne[], int *valeur);
void recherche_chaine(char ligne[], char chaine[]);
int dice_launcher(int nb_dice, int diff_dice, int *resultat_dice, int *win_dice, int current_dice[]);
void menu_dice(int *nb_dice, Personnage *p_perso);
void enregistrer_attribu (int tab_attribu[], Personnage *p_Perso);
void enregistrer_competences (int tab_competence[], Personnage *p_Perso);
void enregistrer_dicipline (int tab_dicipline[], Personnage *p_Perso);
void enregistrer_vertues (int tab_vertues[], Personnage *p_Perso);
void enregistrer_voie (int *voie, Personnage *p_Perso); //ici pas besoin de faire un tableau vu que une seule donne sur voie
int lire_entree(char *entree, int long_max);
int verificateur_nom_perso(char *nom_perso, char perso_save[][NOM_MAX]);
int verificateur_diff ( char entree_diff[], int *diff_dice);
int verificateur_menu (char entree_diff[], int *menu);
int verificateur_vertue (char entree_diff[], int *menu);
int verificateur_dicipline (char entree_diff[], int *menu);
int verificateur_competence (char entree_diff[], int *menu);
int verificateur_attribu (char entree_diff[], int *menu);
int verificateur_simple_double ( char entree[], int *menu);